/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.GolonganPegawaiDto;
import com.portofolio.service.GolonganPegawaiService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/golonganPegawai")
public class GolonganPegawaiController extends LocaleController {
    @Lazy
	@Autowired
    private GolonganPegawaiService golonganPegawaiService;
    
    
    @ApiOperation("Api Untuk Menyimpan GolonganPegawai")
    @PostMapping("/save")
    public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody GolonganPegawaiDto entity,HttpServletRequest request) {
        Map<String, Object> result = golonganPegawaiService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
    
    @ApiOperation("Api Untuk Update GolonganPegawai")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "kdGolonganPegawai", required = true) Integer kdGolonganPegawai,
    		@RequestParam(value = "version", required = true) Integer version,
    		@Valid @RequestBody GolonganPegawaiDto entity, HttpServletRequest request) {
        Map<String, Object> result = golonganPegawaiService.update(entity,kdGolonganPegawai,version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menghapus GolonganPegawai Berdasarkan KdGolonganPegawai")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdGolonganPegawai", required = true) Integer kdGolonganPegawai,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = golonganPegawaiService.deleteById(kdGolonganPegawai, version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Semua GolonganPegawai")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(
    		@RequestParam(value = "page", defaultValue = "1") Integer page, 
    		@RequestParam(value = "rows", defaultValue = "10") Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "namaGolonganPegawai") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaGolonganPegawai", required = false) String namaGolonganPegawai,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = golonganPegawaiService.grid(page, rows, sort, dir, namaGolonganPegawai,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan GolonganPegawai Berdasarkan kdGolonganPegawai")
    @GetMapping("/findByKdGolonganPegawai")
    public ResponseEntity<Map<String, Object>> findByKdGolonganPegawai(
    		@RequestParam(value = "kdGolonganPegawai", required = true) Integer kdGolonganPegawai, 
    		HttpServletRequest request) {
        Map<String, Object> result = golonganPegawaiService.findByKdGolonganPegawai(kdGolonganPegawai);
        return RestUtil.getJsonResponse(result);
    }


}
